/*

File: common.h
Version: v0.3 nov 2008
By: Eric

*/

#ifndef COMMON_INCLUDED
#define COMMON_INCLUDED

#define CPU7FREQ 33513982
#define CPU9FREQ 67027964

#define SAMPLERATE 8192
#define AUDIOBUFLEN 8192

// ARM7 sound device timer count value (n = freq)
#define TIMER7_S_COUNT(n) (-CPU7FREQ / (2 * n))

// ARM7 timer count value (n = freq)
#define TIMER7_N_COUNT(n)  (-CPU7FREQ / (n))

#define VBLANK_FREQ 59.8261
//#define VBLANK_FREQ 60

typedef struct PacketHeader
{
	unsigned long audioIndex;
	unsigned long sampleCount;
} __attribute__ ((__packed__)) tPacketHeader;

typedef struct DrawData
{
	u8 x1;
	u8 x2;
	u8 y1;
	u8 y2;
	u8 pen;
} __attribute__ ((__packed__)) tDrawData;

typedef struct sTalkieIPC
{	
	u8 *micBuffer;
	
	vuint32 micFrames; // number of VBlanks since mic start
	vuint32 micFrameOffset; // number of samples after last VBlank
	vuint32 micWriterPos; // position of last mic sample in ringbuffer
	vuint32 micSampleCount; // number of mic samples (audio index)
		
	vuint32 sndOffset; // micSampleCount value on sound out start

	vuint32 countA;
	vuint32 countB;
	vuint32 countC;
	vuint32 countD;
} TalkieIPC, * pTalkieIPC;


static inline
		TalkieIPC volatile * getTalkieIPC(); // __attribute__ ((deprecated));

static inline
		TalkieIPC volatile * getTalkieIPC() 
{
	// assuming that libnds TransferRegion is only struct in area, we
	// map directly behind it...
	return (TalkieIPC volatile *)( 0x027FF000 + sizeof(TransferRegion) + 4);
}

#define Talkie getTalkieIPC()















#endif
